commit 1fecdb527bc817942d20d37b0664ce3beb05d6ec
Author: Olga Brani <olgabrani@grnet.gr>
Date:   Thu Dec 12 16:59:14 2013 +0200

    new ui: fix left sidebar icon bug for pithos view

diff --git a/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css b/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css
index ba5a693..690a18f 100644
--- a/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css
+++ b/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css
@@ -7810,37 +7810,39 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
 /* line 207, ../sass/_items-list.scss */
 .list-view .lt-bar ul.lt-actions li a span, .storage-progress .lt-bar ul.lt-actions li a span {
   margin-right: 6px;
+  width: 14px;
+  display: inline-block;
 }
-/* line 209, ../sass/_items-list.scss */
+/* line 211, ../sass/_items-list.scss */
 .list-view .lt-bar ul.lt-actions li a span.snf-folder-move-outline, .storage-progress .lt-bar ul.lt-actions li a span.snf-folder-move-outline {
   font-size: 1.5em;
   position: relative;
   top: -2px;
 }
-/* line 221, ../sass/_items-list.scss */
+/* line 223, ../sass/_items-list.scss */
 .list-view .lt-bar ul.more li a span, .storage-progress .lt-bar ul.more li a span {
   font-size: 1.5em;
 }
-/* line 229, ../sass/_items-list.scss */
+/* line 231, ../sass/_items-list.scss */
 .list-view .items-list, .storage-progress .items-list {
   overflow: hidden;
 }
-/* line 231, ../sass/_items-list.scss */
+/* line 233, ../sass/_items-list.scss */
 .list-view .items-list > li, .storage-progress .items-list > li {
   height: auto;
   width: 100%;
   padding: 15px 15px 15px 150px;
   background-image: none;
 }
-/* line 232, ../sass/_items-list.scss */
+/* line 234, ../sass/_items-list.scss */
 .list-view .items-list > li.selected, .storage-progress .items-list > li.selected {
   background-color: #ebebec;
 }
-/* line 240, ../sass/_items-list.scss */
+/* line 242, ../sass/_items-list.scss */
 .list-view .items-list > li:hover, .storage-progress .items-list > li:hover {
   background-color: #dfdfdf;
 }
-/* line 243, ../sass/_items-list.scss */
+/* line 245, ../sass/_items-list.scss */
 .list-view .items-list > li .check, .storage-progress .items-list > li .check {
   width: 60px;
   height: 34px;
@@ -7848,12 +7850,12 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
   text-align: center;
   float: left;
 }
-/* line 249, ../sass/_items-list.scss */
+/* line 251, ../sass/_items-list.scss */
 .list-view .items-list > li .check:hover, .storage-progress .items-list > li .check:hover {
   cursor: pointer;
   color: #30c79e;
 }
-/* line 254, ../sass/_items-list.scss */
+/* line 256, ../sass/_items-list.scss */
 .list-view .items-list > li .img-wrap, .storage-progress .items-list > li .img-wrap {
   width: 70px;
   float: left;
@@ -7861,7 +7863,7 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
   height: 34px;
   top: -6px;
 }
-/* line 260, ../sass/_items-list.scss */
+/* line 262, ../sass/_items-list.scss */
 .list-view .items-list > li .img-wrap .os, .storage-progress .items-list > li .img-wrap .os {
   background: url("../images/os-unknown.png") no-repeat center center;
   width: 14px;
@@ -7877,12 +7879,12 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
   margin-left: -7px;
   top: 6px;
 }
-/* line 271, ../sass/_items-list.scss */
+/* line 273, ../sass/_items-list.scss */
 .list-view .items-list > li .img-wrap .snf-font, .storage-progress .items-list > li .img-wrap .snf-font {
   font-size: 34px;
   line-height: 120%;
 }
-/* line 276, ../sass/_items-list.scss */
+/* line 278, ../sass/_items-list.scss */
 .list-view .items-list > li h4, .storage-progress .items-list > li h4 {
   width: 210px;
   overflow: hidden;
@@ -7892,18 +7894,18 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
   margin: 0;
   color: inherit;
 }
-/* line 285, ../sass/_items-list.scss */
+/* line 287, ../sass/_items-list.scss */
 .list-view .items-list > li .tags, .storage-progress .items-list > li .tags {
   float: left;
   width: 90px;
   height: 34px;
   line-height: 34px;
 }
-/* line 290, ../sass/_items-list.scss */
+/* line 292, ../sass/_items-list.scss */
 .list-view .items-list > li .tags a, .storage-progress .items-list > li .tags a {
   vertical-align: text-top;
 }
-/* line 294, ../sass/_items-list.scss */
+/* line 296, ../sass/_items-list.scss */
 .list-view .items-list > li .size, .list-view .items-list > li .remove, .storage-progress .items-list > li .size, .storage-progress .items-list > li .remove {
   float: left;
   width: 90px;
@@ -7912,7 +7914,7 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
   font-size: 0.75em;
   text-align: left;
 }
-/* line 302, ../sass/_items-list.scss */
+/* line 304, ../sass/_items-list.scss */
 .list-view .items-list > li .status, .storage-progress .items-list > li .status {
   position: absolute;
   left: 280px;
@@ -7920,11 +7922,11 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
   top: 30px;
   width: 210px;
 }
-/* line 308, ../sass/_items-list.scss */
+/* line 310, ../sass/_items-list.scss */
 .list-view .items-list > li .status span, .storage-progress .items-list > li .status span {
   display: inline;
 }
-/* line 312, ../sass/_items-list.scss */
+/* line 314, ../sass/_items-list.scss */
 .list-view .items-list > li .info, .list-view .items-list > li .progress-col, .storage-progress .items-list > li .info, .storage-progress .items-list > li .progress-col {
   float: left;
   width: 200px;
@@ -7932,7 +7934,7 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
   line-height: 34px;
   font-size: 0.75em;
 }
-/* line 319, ../sass/_items-list.scss */
+/* line 321, ../sass/_items-list.scss */
 .list-view .items-list > li .actions, .storage-progress .items-list > li .actions {
   float: left;
   height: 34px;
@@ -7941,11 +7943,11 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
   top: -4px;
   margin: 0 10px;
 }
-/* line 327, ../sass/_items-list.scss */
+/* line 329, ../sass/_items-list.scss */
 .list-view .items-list > li .actions a:first-child, .storage-progress .items-list > li .actions a:first-child {
   margin-right: 5px;
 }
-/* line 332, ../sass/_items-list.scss */
+/* line 334, ../sass/_items-list.scss */
 .list-view .items-list > li .actions-col, .list-view .items-list > li .remove, .storage-progress .items-list > li .actions-col, .storage-progress .items-list > li .remove {
   visibility: hidden;
   height: 34px;
@@ -7954,66 +7956,66 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
   width: 140px;
   float: left;
 }
-/* line 339, ../sass/_items-list.scss */
+/* line 341, ../sass/_items-list.scss */
 .list-view .items-list > li .actions-col a, .list-view .items-list > li .remove a, .storage-progress .items-list > li .actions-col a, .storage-progress .items-list > li .remove a {
   margin-right: 10px;
 }
-/* line 344, ../sass/_items-list.scss */
+/* line 346, ../sass/_items-list.scss */
 .list-view .items-list > li.add-new:hover, .storage-progress .items-list > li.add-new:hover {
   background: #485057;
 }
-/* line 347, ../sass/_items-list.scss */
+/* line 349, ../sass/_items-list.scss */
 .list-view .items-list > li.add-new .check, .storage-progress .items-list > li.add-new .check {
   visibility: hidden;
 }
-/* line 350, ../sass/_items-list.scss */
+/* line 352, ../sass/_items-list.scss */
 .list-view .items-list > li.add-new h4, .storage-progress .items-list > li.add-new h4 {
   margin: 0;
 }
-/* line 356, ../sass/_items-list.scss */
+/* line 358, ../sass/_items-list.scss */
 .list-view .items-list > li.add-new .img-wrap .symbol, .storage-progress .items-list > li.add-new .img-wrap .symbol {
   font-size: 24px;
 }
-/* line 363, ../sass/_items-list.scss */
+/* line 365, ../sass/_items-list.scss */
 .list-view .items-list > li.building .img-wrap .incomplete, .storage-progress .items-list > li.building .img-wrap .incomplete {
   width: 34px;
   margin: 0 auto;
 }
-/* line 367, ../sass/_items-list.scss */
+/* line 369, ../sass/_items-list.scss */
 .list-view .items-list > li.building .img-wrap .complete, .storage-progress .items-list > li.building .img-wrap .complete {
   top: -34px;
   margin: 0 auto;
 }
 
-/* line 379, ../sass/_items-list.scss */
+/* line 381, ../sass/_items-list.scss */
 .lt-bar .items-list .check, .lt-bar .items-list .actions, .lt-bar .items-list .info {
   display: none;
 }
-/* line 382, ../sass/_items-list.scss */
+/* line 384, ../sass/_items-list.scss */
 .lt-bar .items-list > li {
   background: url(../images/dashed_atom-x.png) repeat-x center bottom;
   padding: 40px;
   height: auto;
 }
-/* line 386, ../sass/_items-list.scss */
+/* line 388, ../sass/_items-list.scss */
 .lt-bar .items-list > li:hover {
   background-color: #ebebec;
 }
-/* line 389, ../sass/_items-list.scss */
+/* line 391, ../sass/_items-list.scss */
 .lt-bar .items-list > li.add-new {
   background-color: #30c79e;
 }
-/* line 391, ../sass/_items-list.scss */
+/* line 393, ../sass/_items-list.scss */
 .lt-bar .items-list > li.add-new:hover {
   background-color: #485057;
 }
-/* line 396, ../sass/_items-list.scss */
+/* line 398, ../sass/_items-list.scss */
 .lt-bar .items-list .container {
   height: 160px;
   position: relative;
   line-height: 120%;
 }
-/* line 400, ../sass/_items-list.scss */
+/* line 402, ../sass/_items-list.scss */
 .lt-bar .items-list .container .tags {
   width: 100%;
   min-height: 12px;
@@ -8022,18 +8024,18 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
 }
 
 /* img-wrap div ( colors & styles ) */
-/* line 413, ../sass/_items-list.scss */
+/* line 415, ../sass/_items-list.scss */
 .img-wrap {
   width: 60px;
   position: relative;
   display: inline-block;
   line-height: 100%;
 }
-/* line 420, ../sass/_items-list.scss */
+/* line 422, ../sass/_items-list.scss */
 .img-wrap span:hover {
   cursor: pointer;
 }
-/* line 424, ../sass/_items-list.scss */
+/* line 426, ../sass/_items-list.scss */
 .img-wrap .os {
   background: url("../images/os-unknown.png") no-repeat center center;
   width: 22px;
@@ -8046,19 +8048,19 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
   left: 50%;
   margin-left: -11px;
 }
-/* line 430, ../sass/_items-list.scss */
+/* line 432, ../sass/_items-list.scss */
 .img-wrap .os.windows {
   background-image: url("../images/os-windows.png");
 }
-/* line 431, ../sass/_items-list.scss */
+/* line 433, ../sass/_items-list.scss */
 .img-wrap .os.kubuntu {
   background-image: url("../images/os-kubuntu.png");
 }
-/* line 432, ../sass/_items-list.scss */
+/* line 434, ../sass/_items-list.scss */
 .img-wrap .os.fedora {
   background-image: url("../images/os-fedora.png");
 }
-/* line 433, ../sass/_items-list.scss */
+/* line 435, ../sass/_items-list.scss */
 .img-wrap .os.symbol {
   position: relative;
   top: -50px;
@@ -8138,16 +8140,16 @@ body .jspVerticalBar .jspArrow.jspArrowUp {
   color: #30c79e;
 }
 
-/* line 470, ../sass/_items-list.scss */
+/* line 472, ../sass/_items-list.scss */
 .building .img-wrap .snf-pc-full {
   display: block;
 }
-/* line 474, ../sass/_items-list.scss */
+/* line 476, ../sass/_items-list.scss */
 .building .img-wrap .incomplete {
   color: #54d6b3;
   width: 60px;
 }
-/* line 478, ../sass/_items-list.scss */
+/* line 480, ../sass/_items-list.scss */
 .building .img-wrap .complete {
   width: 0%;
   position: absolute;